#ifndef GLOBAL_HH
#define GLOBAL_HH

#include <iostream>

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>

class Cfile;
class Cconverter;
class Cdata_reader;

/* data size */
/* sizeof(data_t) must be 2byte!! */
/* sizeof(d_data_t) must be 4byte!! */
typedef short data_t;
typedef int d_data_t;

/* maybe LEN(legth) and SIZE(size) is same meaning : byte */

/* one block size(16kbyte) */
static const size_t BLOCK_SIZE(0x4000);
/* maximum one line length(byte) */
static const size_t MAX_ONE_LINE_LEN(BLOCK_SIZE);

/* blank */
static const unsigned short BLANK(0x0000);

/* flags for header */
static const unsigned short FLAG_OF_HEADER(0x0001);
/* NUM : word num, LEN : size of word(byte) */
static const int FLAG_OF_HEADER_NUM(0);
static const size_t FLAG_OF_HEADER_LEN(2);
static const int HEADER_BLANK_NUM(1);
static const size_t HEADER_BLANK_LEN(18);
static const int RUN_NUMBER_NUM(10);
static const size_t RUN_NUMBER_LEN(8);
static const int START_TIME_NUM(15);
static const size_t START_TIME_LEN(18);
static const int STOP_TIME_NUM(24);
static const size_t STOP_TIME_LEN(18);
static const int PRINT_TIME_NUM(34);
static const size_t PRINT_TIME_LEN(18);
static const int PRINT_DATE_NUM(43);
static const size_t PRINT_DATE_LEN(10);
static const int HEADER_NUM(50);
static const size_t HEADER_LEN(80);
static const int ENDER_NUM(90);
static const size_t ENDER_LEN(80);
static const size_t REST_LEN(0x4000 - 260);

/* flags for event block */
static const unsigned short FLAG_OF_EVENT_BLOCK(0x0000);
/* NUM : word num, LEN : size of word(byte) */
static const int FLAG_OF_EVENT_BLOCK_NUM(0);
static const size_t FLAG_OF_EVENT_BLOCK_LEN(2);
static const int EVENT_BLOCK_BLANK_NUM(1);
static const size_t EVENT_BLOCK_BLANK_LEN(6);
static const int EVENT_SIZE_NUM(4);
static const size_t EVENT_SIZE_LEN(2);
static const unsigned short FLAG_OF_EVENT_SIZE(0x8000);
static const int FID_NUM(5);
static const size_t FID_LEN(2);
static const unsigned short FLAG_OF_FID(0x0001);
static const int EVENT_ID_NUM(6);
static const size_t EVENT_ID_LEN(2);
static const int SEGMENT_SIZE_NUM(7);
static const size_t SEGMENT_SIZE_LEN(2);
static const int SEGMENT_ID_NUM(8);
static const size_t SEGMENT_ID_LEN(2);
static const int DATA_NUM(9);
static const size_t DATA_LEN(2);
static const unsigned short FLAG_OF_END_OF_EVENT_BLOCK(0xffff);

static const int SEGMENT_SIZE(SEGMENT_SIZE_LEN + SEGMENT_ID_LEN);
static const int EVENT_SIZE(EVENT_SIZE_LEN + FID_LEN +
			     EVENT_ID_LEN + SEGMENT_SIZE);

/* flags for ender(same as header) */
static const unsigned short FLAG_OF_ENDER(0xffff);
/* NUM : word num, LEN : size of word(byte) */
static const int FLAG_OF_ENDER_NUM(0);
static const size_t FLAG_OF_ENDER_LEN(2);
static const int ENDER_BLANK_NUM(1);
static const size_t ENDER_BLANK_LEN(18);

/* return integer */
static const int ERROR(-1);
static const int OK(0);
static const int END_OF_FILE(1); 
static const int END_OF_LINE(2);
static const int READ_ONE_DATA(3);
static const int COMMENT(4);
static const int NOT_COMMENT(5);
static const int NUMBER(6);
static const int NOT_NUMBER(7);
static const int INT(8);
static const int FLOAT(9);

/* for common use */
int decode_binary_to_string(data_t data_block[], char* str,
			    int word_num, int word_len);
int decode_binary_to_integer(data_t data_block[], int* data,
			     int word_num, int word_len);

#endif
